// Coleccion de Funciones creadas por mi u otros programadores para xBase / Clipper / Harbour / HMG

#include <hmg.ch>				// Para compilar con HMG

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion GetBiosDate () -> Devuelve la fecha de fabricación de la BIOS

Function GetBiosDate

LOCAL obj, oLocator, oWmi, oCollection
LOCAL cInfo := ""
   
	oLocator := win_oleCreateObject ( "wbemScripting.SwbemLocator" )
	oWmi     := oLocator:ConnectServer ()
	oCollection:= oWmi:ExecQuery (" SELECT * FROM Win32_BIOS")
	
	For Each obj IN oCollection

		cInfo := Hb_ValToStr ( obj:ReleaseDate )
		
	Next

Return SubStr (cInfo, 7, 2) + "/" + SubStr (cInfo, 5, 2) + "/" + SubStr (cInfo, 1, 4)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion GS1 () -> Devuelve un Array con el/los nombre/s del/los pais/es al/los que corresponde el
// codigo GS1 ingresado como parametro.
// Recibe un parametro Numerico o Character de 3 digitos.
// Devuelve un Array de 3 (Tres) Items (Paises).
// Creada por Claudio Ricardo Folgán --- Diciembre 2020

Function GS1 (par)

LOCAL aRes [3]

	If Len (par) <> 3

		aRes := {"Error","",""}
		Return aRes
		
	EndIf
	
	If ValType (par) = "C"
	
		par := Val (par)
		
	EndIf
	
	DO Case

		Case par < 20
			aRes := {"Estados Unidos","",""}
		Case par > 29 .AND. par < 40
			aRes := {"Estados Unidos","",""}
		Case par > 59 .AND. par < 140
			aRes := {"Estados Unidos","",""}
		Case par > 299 .AND. par < 380
			aRes := {"Francia","Monaco",""}
		Case par == 380
			aRes := {"Bulgaria","",""}
		Case par == 383
			aRes := {"Eslovenia","",""}
		Case par == 385
			aRes := {"Croacia","",""}
		Case par == 387
			aRes := {"Bosnia y Herzegovina","",""}
		Case par == 389
			aRes := {"Montenegro","",""}
		Case par == 390
			aRes := {"Kosovo","",""}
		Case par > 399 .AND. par < 441
			aRes := {"Alemania","",""}
		Case par > 449 .AND. par < 460
			aRes := {"Japon","",""}
		Case par > 459 .AND. par < 470
			aRes := {"Federacion Rusa","",""}
		Case par == 470
			aRes := {"Kirguistan","",""}
		Case par == 471
			aRes := {"Taiwan","",""}
		Case par == 474
			aRes := {"Estonia","",""}
		Case par == 475
			aRes := {"Letonia","",""}
		Case par == 476
			aRes := {"Azerbaiyan","",""}
		Case par == 477
			aRes := {"Lituania","",""}
		Case par == 478
			aRes := {"Uzbekistan","",""}
		Case par == 479
			aRes := {"Sri Lanka","",""}
		Case par == 480
			aRes := {"Filipinas","",""}
		Case par == 481
			aRes := {"Bielorrusia","",""}
		Case par == 482
			aRes := {"Ucrania","",""}
		Case par == 483
			aRes := {"Turkmenistan","",""}
		Case par == 484
			aRes := {"Moldavia","",""}
		Case par == 485
			aRes := {"Armenia","",""}
		Case par == 486
			aRes := {"Georgia","",""}
		Case par == 487
			aRes := {"Kazajistan","",""}
		Case par == 488
			aRes := {"Tayikistan","",""}
		Case par == 489
			aRes := {"Hong Kong","",""}
		Case par > 489 .AND. par < 500
			aRes := {"Japon","",""}
		Case par > 499 .AND. par < 510
			aRes := {"Reino Unido","",""}
		Case par == 520 .OR. par == 521
			aRes := {"Grecia","",""}
		Case par == 528
			aRes := {"Libano","",""}
		Case par == 529
			aRes := {"Chipre","",""}
		Case par == 530
			aRes := {"Albania","",""}
		Case par == 531
			aRes := {"Macedonia","",""}					// Macedonia del Norte
		Case par == 535
			aRes := {"Malta","",""}
		Case par == 539
			aRes := {"Irlanda","",""}
		Case par > 539 .AND. par < 550
			aRes := {"Belgica","Luxemburgo",""}
		Case par == 560
			aRes := {"Portugal","",""}
		Case par == 569
			aRes := {"Islandia","",""}
		Case par > 569 .AND. par < 580
			aRes := {"Dinamarca","Islas Feroe","Groenlandia"}
		Case par == 590
			aRes := {"Polonia","",""}
		Case par == 594
			aRes := {"Rumania","",""}
		Case par == 599
			aRes := {"Hungria","",""}
		Case par == 600 .OR. par == 601
			aRes := {"Sudafrica","",""}
		Case par == 603
			aRes := {"Ghana","",""}
		Case par == 604
			aRes := {"Senegal","",""}
		Case par == 608
			aRes := {"Bahrein","",""}
		Case par == 609
			aRes := {"Mauricio","",""}
		Case par == 611
			aRes := {"Marruecos","",""}
		Case par == 613
			aRes := {"Argelia","",""}
		Case par == 615
			aRes := {"Nigeria","",""}
		Case par == 616
			aRes := {"Kenia","",""}
		Case par == 617
			aRes := {"Camerun","",""}
		Case par == 618
			aRes := {"Costa De Marfil","",""}
		Case par == 619
			aRes := {"Tunez","",""}
		Case par == 620
			aRes := {"Tanzania","",""}
		Case par == 621
			aRes := {"Siria","",""}
		Case par == 622
			aRes := {"Egipto","",""}
		Case par == 623
			aRes := {"Brunei","",""}
		Case par == 624
			aRes := {"Libia","",""}
		Case par == 625
			aRes := {"Jordania","",""}
		Case par == 626
			aRes := {"Iran","",""}
		Case par == 627
			aRes := {"Kuwait","",""}
		Case par == 628
			aRes := {"Arabia Saudita","",""}
		Case par == 629
			aRes := {"Emiratos Arabes Unidos","",""}
		Case par == 630
			aRes := {"Catar","",""}
		Case par > 639 .AND. par < 650
			aRes := {"Finlandia","",""}
		Case par > 689 .AND. par < 700
			aRes := {"China","",""}
		Case par > 699 .AND. par < 710
			aRes := {"Noruega","",""}
		Case par == 729
			aRes := {"Israel","",""}
		Case par > 729 .AND. par < 740
			aRes := {"Suecia","",""}
		Case par == 740
			aRes := {"Guatemala","",""}
		Case par == 741
			aRes := {"El Salvador","",""}
		Case par == 742
			aRes := {"Honduras","",""}
		Case par == 743
			aRes := {"Nicaragua","",""}
		Case par == 744
			aRes := {"Costa Rica","",""}
		Case par == 745
			aRes := {"Panama","",""}
		Case par == 746
			aRes := {"Republica Dominicana","",""}
		Case par == 750
			aRes := {"Mexico","",""}
		Case par == 754 .OR. par == 755
			aRes := {"Canada","",""}
		Case par == 759
			aRes := {"Venezuela","",""}
		Case par > 759 .AND. par < 770
			aRes := {"Suiza","Liechtenstein",""}
		Case par == 770 .OR. par == 771
			aRes := {"Colombia","",""}
		Case par == 773
			aRes := {"Uruguay","",""}
		Case par == 775
			aRes := {"Peru","",""}
		Case par == 777
			aRes := {"Bolivia","",""}
		Case par == 778 .OR. par == 779
			aRes := {"Argentina","",""}
		Case par == 780
			aRes := {"Chile","",""}
		Case par == 784
			aRes := {"Paraguay","",""}
		Case par == 786
			aRes := {"Ecuador","",""}
		Case par == 789 .OR. par == 790
			aRes := {"Brasil","",""}
		Case par > 799 .AND. par < 840
			aRes := {"Italia","San Marino","Ciudad Del Vaticano"}
		Case par > 839 .AND. par < 850
			aRes := {"España","Andorra",""}
		Case par == 850
			aRes := {"Cuba","",""}
		Case par == 858
			aRes := {"Eslovaquia","",""}
		Case par == 859
			aRes := {"Republica Checa","",""}
		Case par == 860
			aRes := {"Serbia","",""}
		Case par == 865
			aRes := {"Mongolia","",""}
		Case par == 867
			aRes := {"Corea Del Norte","",""}
		Case par == 868 .OR. par == 869
			aRes := {"Turquia","",""}
		Case par > 869 .AND. par < 880
			aRes := {"Paises Bajos","",""}
		Case par == 880
			aRes := {"Corea Del Sur","",""}
		Case par == 883
			aRes := {"Myanmar","",""}
		Case par == 884
			aRes := {"Camboya","",""}
		Case par == 885
			aRes := {"Tailandia","",""}
		Case par == 888
			aRes := {"Singapur","",""}
		Case par == 890
			aRes := {"India","",""}
		Case par == 893
			aRes := {"Vietnam","",""}
		Case par == 896
			aRes := {"Pakistan","",""}
		Case par == 899
			aRes := {"Indonesia","",""}
		Case par > 899 .AND. par < 920
			aRes := {"Austria","",""}
		Case par > 929 .AND. par < 940
			aRes := {"Australia","",""}
		Case par > 939 .AND. par < 950
			aRes := {"Nueva Zelanda","",""}

		Case par == 950
			aRes := {"Head Office","",""}

		Case par == 955
			aRes := {"Malasia","",""}
		Case par == 958
			aRes := {"Macao","",""}

		Case par == 977
			aRes := {"Publicaciones Seriales (ISSN)","",""}
		Case par == 978 .OR. par == 979
			aRes := {"Libros (ISBN)","",""}
		Case par == 980
			aRes := {"Recibos de devolucion","",""}
		Case par == 977
			aRes := {"Publicaciones Seriales (ISSN)","",""}
		Case par == 981 .OR. par == 982
			aRes := {"Cupones","",""}
		Case par > 989 .AND. par < 1000
			aRes := {"Cupones","",""}

		OtherWise
			aRes := {"Desconocido o de uso Privado","",""}
			
	EndCase

Return aRes
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion EanCheck ---> Verifica en un codigo EAN-8 o EAN-13 si el Checksum es correcto (devuelve .T.)
// Recibe Character o Numeric y Retorna Logico
// Precisa la funcion EanCheckSum ()
// Creado por Claudio Ricardo Folgán --- Diciembre 2020

Function EanCheck (cCode)

LOCAL lRetu, cDigit, cCheck

	If ValType (cCode) = "N"
	
		cCode := AllTrim ( Str (cCode))
		
	EndIf

	If Len (cCode) == 8 .OR. Len (cCode) == 13

		cDigit := SubStr (cCode, - 1, 1)
		cCheck := EanCheckSum (SubStr (cCode, 1, Len (cCode) - 1))

		Iif (cDigit == cCheck, lRetu := .T. , lRetu := .F.)

	Else

		lRetu := .F.
		
	EndIf

Return lRetu
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Genera el digito verificador acorde al standard EAN (Checksum) del codigo ingresado
// Recibe Character o Numeric y Retorna 1 digito Character
// Creado por Claudio Ricardo Folgán --- Diciembre 2020

Function EanCheckSum (cCode)

LOCAL nSuma, nDigit, i
   
	If ValType (cCode) = "N"
	
		cCode := AllTrim ( Str (cCode))
		
	EndIf

	nSuma := 0
   
	For i = Len (cCode) To 1 Step - 1
		
		nDigit = Val (SubStr (cCode, i, 1))

		If (Mod (Len (cCode) - i + 1, 2)) <> 0

			nSuma = nSuma + (nDigit * 3)

		Else

			nSuma = nSuma + nDigit
			
		EndIf

	Next

Return Str (Mod (10 - Mod (nSuma, 10), 10),1,0)

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Capitaliza una cadena de texto / Frase ANSI o Unicode

Function Capitalize (cString)

LOCAL cTarget := " "
LOCAL cCadCap := ""
LOCAL lFlag := .T.
LOCAL Pos

cString := HMG_Lower (cString)

	For Pos = 1 To HMG_Len (cString)

		DO Case
		
			Case ! Hb_UsubStr (cString,Pos,1) == cTarget .AND. lFlag
				lFlag = .F.
				cCadCap = cCadCap + HMG_Upper (Hb_UsubStr (cString,Pos,1))
				
			Case Hb_UsubStr (cString,Pos,1) == cTarget
				lFlag = .T.
				cCadCap = cCadCap + Hb_UsubStr (cString,Pos,1)
				
			OtherWise
			
				cCadCap = cCadCap + Hb_UsubStr (cString,Pos,1)
				
		EndCase

	Next

Return cCadCap

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Convierte a mayusculas la letra siguiente al caracter contenido en Cad2
// Tomada del libro 109 funciones Clipper

Function Fupper (Cad1)

LOCAL Cad2 := " ,;.:-_'{}[]()*+<>?!`~=/\%$@#|"+Chr (34)
LOCAL Pos,Switch,Cad3
Switch = .T.
Cad1 = Lower (Cad1)
Cad3 = Space (0)

   For Pos = 1 To Len (Cad1)
       DO Case
          Case ! SubStr (Cad1,Pos,1)$Cad2 .AND. Switch
               Switch = .F.
               Cad3 = Cad3 + Upper (SubStr (Cad1,Pos,1))
          Case SubStr (Cad1,Pos,1)$Cad2
               Switch = .T.
               Cad3 = Cad3 + SubStr (Cad1,Pos,1)
          OtherWise
               Cad3 = Cad3 + SubStr (Cad1,Pos,1)
       EndCase
   Next
   
	Cad1 = Cad3
	
Return Cad1

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// ShortTime = Return Hour in short format " xx:xx " Whitout params return current hour
// Creada por Claudio Ricardo Folgán

Function ShortTime (cTime)

	If Empty (cTime)
	
		cTime := Time ()
	EndIf
	
Return AllTrim ( SubStr (cTime,1,5))

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// HtoM = Hour to Minutes
// Funcion para obtener la cantidad de minutos contenida en la expresion horaria ingresada
// Ejemplo: cTiempo := 02:30:00 --- HtoM (cTiempo) devuelve: 150 (Cantidad de minutos en 2 horas y media)
// Los segundos no se toman en cuenta
// Ingresa una CADENA en formato "hh:mm:ss" y devuelve un valor NUMERICO
// Creada por Claudio Ricardo Folgán

Function HtoM (cTime)

LOCAL nHora,nMinu

	nHora := 60 * Val (SubStr (cTime,1,2))
	nMinu := Val (SubStr (cTime,4,2))

Return nHora + nMinu

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// MtoH = Minutes to Hour
// Funcion para convertir los MINUTOS a formato Hora
// Ingresa formato NUMERICO y devuelve formato CARACTER "hh:mm:ss"
// Ejemplo: nMin := 160 --- MtoH (nMin) devuelve: 02:40:00
// Creada por Claudio Ricardo Folgán

Function MtoH (nMin)

LOCAL cHoras,cMinutos

	cHoras := AllTrim (Str (Int (nMin / 60)))
	cMinutos := AllTrim (Str (Int (Mod (nMin,60))))

	If Len (cHoras) == 1
	
		cHoras = "0" + cHoras
	EndIf
	
	If Len (cMinutos) == 1
	
		cMinutos = "0" + cMinutos
	EndIf

Return AllTrim (cHoras + ":" + cMinutos + ":00")

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// NtoH = Numeric to Hour
// Funcion para obtener la HORA en formato HH:MM:SS a partir de 2 o 3 parametros numericos
// Primer parametro: la Hora, Segundo parametro: los Minutos, Tercer parametro: los Segundos.
// Si se ingresa un solo digito en cualquiera de los parametros se rellenara con 0 (Cero) a la izquierda.
// Ingresa formato NUMERICO y devuelve formato CARACTER "hh:mm:ss"
// Si no se especifican los segundos devuelve 00 en su lugar
// Creada por Claudio Ricardo Folgán

Function NtoH (nHor,nMin,nSeg)

LOCAL cHor,cMin,cSeg,cHora

	If Pcount () == 2
	
		nSeg = 0
	EndIf

	cHor = AllTrim (Str (nHor))
	cMin = AllTrim (Str (nMin))
	cSeg = AllTrim (Str (nSeg))
	
	If Len (cHor) == 1
	
		cHor = "0" + cHor
	EndIf
	
	If Len (cMin) == 1
	
		cMin = "0" + cMin
	EndIf
	
	If Len (cSeg) == 1
	
		cSeg = "0" + cSeg
	EndIf
	
	cHora = AllTrim (cHor + ":" + cMin + ":" + cSeg)
	
Return cHora

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion para obtener la IP local de la red
// Agradecimiento a Daniel Crocciari (Brasil) por la idea.

Function GetLanIp

LOCAL aLanIp := {}, cLanIp := ""

	InetInit ()
	
	aLanIp := InetGetHosts ( NetName ())
	
	Iif (Empty (aLanIp), aLanIp := InetGetAlias ( NetName ()), )
	
	Iif (aLanIp [1] == "127.0.0.1", cLanIp := aLanIp [1] + "   Sin coneccion a LAN", cLanIp := aLanIp [1])
		
	InetCleanUp ()

Return cLanIp

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion GetPublicIp
// Hace un pedido a " dyndns.org " luego extrae solo la IP del HTML recibido.
// Retorna un string con la IP publica de la conexion a internet
// Creada por Claudio Ricardo Folgán sobre una idea de HMG Forum.

Function GetPublicIp

LOCAL cUrl, oUrl, oCli, cRes, nPosIni, nPosFin

	cUrl := "http://checkip.dyndns.org/"

    Begin Sequence

		oUrl = TUrl ():New ( cUrl )

		IF Empty( oUrl )
			Break
		ENDIF

		oCli = TIpClientHttp ():New ( oUrl )

		IF Empty ( oCli )
			Break
		ENDIF

		oCli:nConnTimeout = 20000

		IF ! oCli:Open ( oUrl )
			Break
		ENDIF

		cRes := oCli:Read ()	// cRes = <html><head><title>Current IP Check</title></head><body>Current IP Address: XXX.XXX.XXX.XXX</body></html>
		oCli:Close ()

    End Sequence

	If .NOT. Empty (cRes)
												// Desde aqui es extraer solo la IP del HTML que devolvio el DNS
		nPosIni := At (":", cRes)
		cRes := SubStr( cRes, nPosIni + 1)		// Borro hasta los 2 puntos ( : ) mas el espacio
		nPosFin := At ("<", cRes) - 1
		cRes := SubStr (cRes,1,nPosFin)			// Extraigo hasta el primer "Menor que" ( < )
		cRes := AllTrim (cRes)
	EndIf

Return Iif (Empty (cRes),"DNS no disponible !",cRes)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion para generarar un numero de cliente irrepetible basado en la fecha y segundos pasada medianoche mas 10000
// Devuelve un Numero de 11 digitos.
// Creada por Claudio Ricardo Folgán

Function FnumCli

Local dDate := DtoS ( Date ())
Local nNumCli := 0

	Local nNumeroCliente := AllTrim ( SubStr ( dDate ,3,6)) + AllTrim (Str (10000 + Secs (Time ())))

	nNumCli := Val ( nNumeroCliente )

Return nNumCli

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion para determinar si un numero es primo (Devuelve .T.) Primo = Divisible por si mismo o por 1 solamente

Function IsPrimo (nNum)

PRIVATE Div, Raiz, Resp

Raiz = Sqrt (nNum)
Resp = .T.

	For Div = 2 To Raiz
	
		If Mod (nNum,Div) = 0
			Resp = .F.
			Exit
		EndIf
	Next
	
Return Resp

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion para determinar si un numero es par (Devuelve .T.)

Function IsPar (nValue)

Return Iif (Mod (nValue,2) = 0, .T. , .F.)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion Fencrypt (cString) Sirve para reemplazar caracteres de una cadena por otros
// Ingresar solo caracteres en minusculas  ( Preceder con Lower () )

Function Fencrypt (Cadena)

PRIVATE nLong,cCar,nPos,cCadena,Ind

nLong = Len (Cadena)
cCar = ""
nPos = 1
cCadena = ""
													// Convertir caracter por caracter de la cadena
	For nPos = 1 To nLong
		cCar := SubStr (Cadena,nPos,1)
			Do Case
				Case cCar = "a"
					cCar = "T"
				Case cCar = "b"
					cCar = ")"
				Case cCar = "c"
					cCar = "6"
				Case cCar = "d"
					cCar = "i"
				Case cCar = "e"
					cCar = "/"
				Case cCar = "f"
					cCar = "["
				Case cCar = "g"
					cCar = ";"
				Case cCar = "h"
					cCar = "?"
				Case cCar = "i"
					cCar = "4"
				Case cCar = "j"
					cCar = "#"
				Case cCar = "k"
					cCar = "_"
				Case cCar = "l"
					cCar = ">"
				Case cCar = "m"
					cCar = "*"
				Case cCar = "n"
					cCar = "2"
				Case cCar = "o"
					cCar = "}"
				Case cCar = "p"
					cCar = ":"
				Case cCar = "q"
					cCar = "!"
				Case cCar = "r"
					cCar = "+"
				Case cCar = "s"
					cCar = Chr (39)
				Case cCar = "t"
					cCar = "1"
				Case cCar = "u"
					cCar = "."
				Case cCar = "v"
					cCar = "c"
				Case cCar = "w"
					cCar = "&"
				Case cCar = "x"
					cCar = "-"
				Case cCar = "y"
					cCar = "{"
				Case cCar = "z"
					cCar = "="
				Case cCar = "0"
					cCar = "<"
				Case cCar = "1"
					cCar = "8"
				Case cCar = "2"
					cCar = "("
				Case cCar = "3"
					cCar = "a"
				Case cCar = "4"
					cCar = "h"
				Case cCar = "5"
					cCar = "@"
				Case cCar = "6"
					cCar = "]"
				Case cCar = "7"
					cCar = "m"
				Case cCar = "8"
					cCar = "k"
				Case cCar = "9"
					cCar = "%"
			EndCase
		cCadena = Stuff (cCadena,nPos,1,cCar)
	Next
																//Invertir el resultado
cCadena = SubStr (cCadena,2,nLong -1) + SubStr (cCadena,1,1)

	For Ind = nLong To 3 Step -1
		cCadena = SubStr (cCadena,2,Ind-2) + SubStr (cCadena,1,1) + SubStr (cCadena,Ind,nLong-Ind + 1)
	Next
	
	Cadena = cCadena

Return Cadena

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion Fdecrypt () Sirve para reestablecer la cadena transformada con Fencrypt ()

Function Fdecrypt (Cadena)

PRIVATE nLong,cCar,nPos,cCadena,Ind

nLong = Len (Cadena)
cCar = ""
nPos = 1
cCadena = Cadena
																// Invertir la cadena ingresada
cCadena = SubStr (cCadena,2,nLong -1) + SubStr (cCadena,1,1)

	For Ind = nLong To 3 Step -1
		cCadena = SubStr (cCadena,2,Ind-2) + SubStr (cCadena,1,1) + SubStr (cCadena,Ind,nLong-Ind + 1)
	Next

													// Convertir caracter por caracter de la cadena

	For nPos = 1 To nLong
		cCar := SubStr (cCadena,nPos,1)
			Do Case
				Case cCar = "T"
					cCar = "a"
				Case cCar = ")"
					cCar = "b"
				Case cCar = "6"
					cCar = "c"
				Case cCar = "i"
					cCar = "d"
				Case cCar = "/"
					cCar = "e"
				Case cCar = "["
					cCar = "f"
				Case cCar = ";"
					cCar = "g"
				Case cCar = "?"
					cCar = "h"
				Case cCar = "4"
					cCar = "i"
				Case cCar = "#"
					cCar = "j"
				Case cCar = "_"
					cCar = "k"
				Case cCar = ">"
					cCar = "l"
				Case cCar = "*"
					cCar = "m"
				Case cCar = "2"
					cCar = "n"
				Case cCar = "}"
					cCar = "o"
				Case cCar = ":"
					cCar = "p"
				Case cCar = "!"
					cCar = "q"
				Case cCar = "+"
					cCar = "r"
				Case cCar = Chr (39)
					cCar = "s"
				Case cCar = "1"
					cCar = "t"
				Case cCar = "."
					cCar = "u"
				Case cCar = "c"
					cCar = "v"
				Case cCar = "&"
					cCar = "w"
				Case cCar = "-"
					cCar = "x"
				Case cCar = "{"
					cCar = "y"
				Case cCar = "="
					cCar = "z"
				Case cCar = "<"
					cCar = "0"
				Case cCar = "8"
					cCar = "1"
				Case cCar = "("
					cCar = "2"
				Case cCar = "a"
					cCar = "3"
				Case cCar = "h"
					cCar = "4"
				Case cCar = "@"
					cCar = "5"
				Case cCar = "]"
					cCar = "6"
				Case cCar = "m"
					cCar = "7"
				Case cCar = "k"
					cCar = "8"
				Case cCar = "%"
					cCar = "9"				
			EndCase
		cCadena = Stuff (cCadena,nPos,1,cCar)
	Next
	
	Cadena = cCadena

Return Cadena

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Funcion que reproduce una nota musical //
// Util para afinar instrumentos musicales. //
// Recibe tres parametros = La nota , La octava y el tiempo de duracion en octavos de segundos. //
// Retorna la frecuencia de la nota reproducida //

Function Fnotas (Nota,Octava,Tiempo)

	If Tiempo == Nil
		Tiempo = 1
	EndIf
	
	If Octava == Nil
		Octava = 4
	EndIf
	
	DO Case
		Case Nota == "Do"
			Frec = 261.626
		Case Nota == "Do#"
			Frec = 277.183
		Case Nota == "Re"
			Frec = 293.665
		Case Nota == "Re#"
			Frec = 311.127
		Case Nota == "Mi"
			Frec = 329.628
		Case Nota == "Fa"
			Frec = 349.228
		Case Nota == "Fa#"
			Frec = 369.994
		Case Nota == "Sol"
			Frec = 391.995
		Case Nota == "Sol#"
			Frec = 415.305
		Case Nota == "La"
			Frec = 440
		Case Nota == "La#"
			Frec = 466.164
		Case Nota == "Si"
			Frec = 493.883
		OtherWise
			Frec = 0
	EndCase

	DO Case
		Case Octava = 1
			Frec = Frec / 8
		Case Octava = 2
			Frec = Frec / 4
		Case Octava = 3
			Frec = Frec / 2
		Case Octava = 4
			Frec = Frec
		Case Octava = 5
			Frec = Frec * 2
		Case Octava = 6
			Frec = Frec * 4
		Case Octava = 7
			Frec = Frec * 8
		OtherWise
			Frec = Frec
	EndCase

	Tone (Frec, Tiempo)

Return Frec

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// Muestra la fecha actual en formato: DIA,FECHA,MES y AÑO  //
////////  ­­­ ATENCION !!!  Largo maximo que ocupa: 20 caracteres.   ///////

Function FechaShort

LOCAL nDia := Dow (Date ()) 
LOCAL cDia

	DO Case
		Case nDia = 1
			cDia = "Domingo"
		Case nDia = 2
			cDia = "Lunes"
		Case nDia = 3
			cDia = "Martes"
		Case nDia = 4
			cDia = "Miercoles" 
		Case nDia = 5
			cDia = "Jueves"
		Case nDia = 6
			cDia = "Viernes"
		Case nDia = 7
			cDia = "Sabado"
	EndCase

Return (cDia) + " " + Ltrim(Str(Day(Date()))) + "/" +;
        Ltrim(Str(Month(Date()))) + "/" + Str(Year(Date()),4,0)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////
//// Muestra la fecha actual en formato: DIA,FECHA,(nombre del) MES y AÑO  //
////////  ­­­ ATENCION !!!  Largo maximo que ocupa: 33 caracteres.   ///////

Function FechaLong

LOCAL nMes := Month ( Date ()) 
LOCAL nDia := Dow ( Date ()) 
LOCAL cMes 
LOCAL cDia

	DO Case
		Case nMes = 1
			cMes = "Enero"
		Case nMes = 2
			cMes = "Febrero"
		Case nMes = 3 
			cMes = "Marzo"
		Case nMes = 4
			cMes = "Abril"
		Case nMes = 5
			cMes = "Mayo"
		Case nMes = 6
			cMes = "Junio"
		Case nMes = 7
			cMes = "Julio"
		Case nMes = 8
			cMes = "Agosto"
		Case nMes = 9
			cMes = "Setiembre"
		Case nMes = 10
			cMes = "Octubre"
		Case nMes = 11
			cMes = "Noviembre"
		Case nMes = 12
			cMes = "Diciembre"
	EndCase

	DO Case
		Case nDia = 1
			cDia = "Domingo"
		Case nDia = 2
			cDia = "Lunes"
		Case nDia = 3
			cDia = "Martes"
		Case nDia = 4
			cDia = "Miercoles"
		Case nDia = 5
			cDia = "Jueves"
		Case nDia = 6
			cDia = "Viernes"
		Case nDia = 7
			cDia = "Sabado"
	EndCase

Return (cDia) + " " + StrZero(Day(Date()),2,0) + " de " + (cMes) + " del " + Str(Year(Date()),4,0)

/////////////////////////////////////////////////////////////////////////////////////////////////////////////