#include <hmg.ch>
#include "dll.ch"

#xtranslate DllCall => HMG_CallDLL

//  AutoAdjust (c) 2007-2015 MigSoft / Danny / Pablo César
// -------------------------------------------------------*
// modify by Auge & Ohr, Jimmy


FUNCTION AutoAdjust( cForm )
LOCAL hWnd := GetFormHandle( cForm )
LOCAL hGrid, j, jMax, nWide
LOCAL i, ;                                                            // From no
           k, ;                                                       // Control no
           ParentForm, ;
           ControlCount, ;
           ControlName, ;
           ControlType, ;
           nWidth, ;
           nHeight, ;
           lvisible := .T., ;
           nDivw, ;
           nDivh

   IF GetDesktopWidth() < GetWindowWidth( hWnd )
      nWidth := GetDesktopWidth()
   ELSE
      nWidth := GetWindowWidth( hWnd )
   ENDIF

   IF GetDesktopHeight() < GetWindowHeight( hWnd )
      nHeight := GetDesktopHeight()
   ELSE
      nHeight := GetWindowHeight( hWnd )
   ENDIF

   IF IsWindowVisible( hWnd ) .AND. !IsAppXPThemed()
      HideWindow( hWnd )
   ELSE
      lvisible := .F.
   ENDIF

   i := ASCAN( _HMG_SYSDATA[ 67 ], hWnd )

   ParentForm := _HMG_SYSDATA[ 66 ] [ i ]

   IF _HMG_SYSDATA[ 92, i ] > 0 .AND. _HMG_SYSDATA[ 91, i ] > 0
      nDivw := nWidth  / _HMG_SYSDATA[ 92, i ]
      nDivh := nHeight / _HMG_SYSDATA[ 91, i ]
   ELSE
      nDivw := 1
      nDivh := 1
   ENDIF

   ControlCount := LEN( _HMG_SYSDATA[ 3 ] )

   // disable Update Window
   DllCall( "user32.dll", DLL_OSAPI, "LockWindowUpdate",hWnd)

   FOR k := 1 TO ControlCount
      ControlName := _HMG_SYSDATA[ 2, k ]

      IF _IsControlDefined( ControlName, ParentForm )
         ControlType := UPPER(ALLTRIM(_HMG_SYSDATA[ 1, k ]))

         IF !EMPTY( ControlName ) .AND. !( ControlType $ "MENU,HOTKEY,TOOLBAR,MESSAGEBAR,ITEMMESSAGE,TIMER" )

            DO CASE
               CASE ControlType $ "BUTTON,RADIOGROUP,TEXTBOX"
                  _SetControlSizePos( ControlName, ParentForm, ;
                                      _GetControlRow( ControlName, ParentForm ) * nDivh, ;    // row
                                      _GetControlCol( ControlName, ParentForm ) * nDivw, ;    // column
                                      _GetControlWidth( ControlName, ParentForm ) * nDivw, ;  // with
                                      _GetControlHeight( ControlName, ParentForm )* nDivh )          // height

               CASE ControlType = "SLIDER"
                  _SetControlSizePos( ControlName, ParentForm, ;
                                      _GetControlRow( ControlName, ParentForm ) * nDivh, ;
                                      _GetControlCol( ControlName, ParentForm ) * nDivw, ;
                                      _GetControlWidth( ControlName, ParentForm ) * nDivw,;
                                      _GetControlHeight( ControlName, ParentForm ) * nDivh )

               CASE ControlType = "STATUSBAR"
                  // do nothing

               CASE !ControlType $ "TOOLBUTTON"
                  _SetControlSizePos( ControlName, ParentForm, ;
                                      _GetControlRow( ControlName, ParentForm ) * nDivh, ;
                                      _GetControlCol( ControlName, ParentForm ) * nDivw, ;
                                      _GetControlWidth( ControlName, ParentForm ) * nDivw, ;
                                      _GetControlHeight( ControlName, ParentForm ) * nDivh )

               OTHERWISE
// * move outside DO CASE
                  IF EMPTY( _HMG_SYSDATA[ 28, k ] )
                     _SetFontSize( ControlName, ParentForm, 8 * nDivh )
                  ELSE
                     _SetFontSize( ControlName, ParentForm, _HMG_SYSDATA[ 28 ] [ k ] * nDivh )
                  ENDIF
            ENDCASE

            IF ControlType = "STATUSBAR"
               // do nothing
            // ELSEIF EMPTY( _HMG_SYSDATA[ 28, k ] )
               // _SetFontSize( ControlName, ParentForm, 8 * nDivh )
               // msgdebug(ControlType+" "+ControlName+" not found !")
            ELSE
               _SetFontSize( ControlName, ParentForm, _HMG_SYSDATA[ 28 ] [ k ] * nDivh )
            ENDIF

            IF ControlType = "BROWSE" .or. ControlType = "GRID"
               hGrid := GetControlHandle( ControlName, ParentForm )
               jMax := LEN( _HMG_SYSDATA[6,k] )
               FOR j = 1 TO jMax
                  // * autosize wide
                  // * LISTVIEW_SETCOLUMNWIDTH( hGrid, j - 1, - 1 )

                  nWide  := _HMG_SYSDATA[6,k,j] * nDivw
                  LISTVIEW_SETCOLUMNWIDTH( hGrid, j - 1, nWide )
               NEXT
            ENDIF

         ENDIF
      ENDIF
   NEXT k

   // enable Update Window
   DllCall( "user32.dll", DLL_OSAPI, "LockWindowUpdate",0)

   _HMG_SYSDATA[ 92 ] [ i ] := nWidth
   _HMG_SYSDATA[ 91 ] [ i ] := nHeight

   IF lvisible
      ShowWindow( hWnd )
   ENDIF
RETURN Nil

/*--------------------------------------------------------------------

    Function ISAPPXPTHEMED()

    Called from ( autosize.prg )   1 - function original_autoadjust()

*/

FUNCTION ISAPPXPTHEMED()

RETURN ( OS_ISWINXP_OR_LATER() ;                                      // <= hrb\contrib/hbwin/legacycv.c
         .AND. IsAppThemed() )                                        // <= HMG\h_window.prg

 // EOF: AUTOSIZE.PRG
